/*
 *	File:	startup.c
 *	Date:	03.01.2011
 */

#include "stm32f10x_lib.h"
#include "stm32f10x_it.h"

extern unsigned long _data_flash;
extern unsigned long _data_begin;
extern unsigned long _data_end;
extern unsigned long _bss_begin;
extern unsigned long _bss_end;
extern unsigned long _stack_end;

extern int main(void);

//-----------------------------------------------------------------------------
void handler_reset(void)
{
	unsigned long *source;
	unsigned long *destination;

	// копируем данные из флеки в память
	source = &_data_flash;
	for (destination = &_data_begin; destination < &_data_end;)
	{
		*(destination++) = *(source++);
	}

	// обнуляем
	for (destination = &_bss_begin; destination < &_bss_end;)
	{
		*(destination++) = 0;
	}

	// переход в основную программу
	main();
}

//-----------------------------------------------------------------------------
__attribute__ ((section(".interrupt_vector")))
void (* const table_interrupt_vector[])(void) =
{ (void *) &_stack_end, handler_reset, NMIException, HardFaultException,
		MemManageException, BusFaultException, UsageFaultException, 0, 0, 0, 0,
		SVCHandler, DebugMonitor, 0, PendSVC, SysTickHandler, WWDG_IRQHandler,
		PVD_IRQHandler, TAMPER_IRQHandler, RTC_IRQHandler, FLASH_IRQHandler,
		RCC_IRQHandler, EXTI0_IRQHandler, EXTI1_IRQHandler, EXTI2_IRQHandler,
		EXTI3_IRQHandler, EXTI4_IRQHandler, DMA1_Channel1_IRQHandler,
		DMA1_Channel2_IRQHandler, DMA1_Channel3_IRQHandler,
		DMA1_Channel4_IRQHandler, DMA1_Channel5_IRQHandler,
		DMA1_Channel6_IRQHandler, DMA1_Channel7_IRQHandler, ADC1_2_IRQHandler,
		USB_HP_CAN_TX_IRQHandler, USB_LP_CAN_RX0_IRQHandler,
		CAN_RX1_IRQHandler, CAN_SCE_IRQHandler, EXTI9_5_IRQHandler,
		TIM1_BRK_IRQHandler, TIM1_UP_IRQHandler, TIM1_TRG_COM_IRQHandler,
		TIM1_CC_IRQHandler, TIM2_IRQHandler, TIM3_IRQHandler, TIM4_IRQHandler,
		I2C1_EV_IRQHandler, I2C1_ER_IRQHandler, I2C2_EV_IRQHandler,
		I2C2_ER_IRQHandler, SPI1_IRQHandler, SPI2_IRQHandler,
		USART1_IRQHandler, USART2_IRQHandler, USART3_IRQHandler,
		EXTI15_10_IRQHandler, RTCAlarm_IRQHandler, USBWakeUp_IRQHandler,
		TIM8_BRK_IRQHandler, TIM8_UP_IRQHandler, TIM8_TRG_COM_IRQHandler,
		TIM8_CC_IRQHandler, ADC3_IRQHandler, FSMC_IRQHandler, SDIO_IRQHandler,
		TIM5_IRQHandler, SPI3_IRQHandler, UART4_IRQHandler, UART5_IRQHandler,
		TIM6_IRQHandler, TIM7_IRQHandler, DMA2_Channel1_IRQHandler,
		DMA2_Channel2_IRQHandler, DMA2_Channel3_IRQHandler,
		DMA2_Channel4_5_IRQHandler
};
